#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace MultipleRecordSelection
{
	/// <summary>
	/// This sample shows how to customize the current cell arrow up/down behavior
	/// and highlight the current record.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private DerGridGroupingControl gridGroupingControl1;
		private System.Data.SqlClient.SqlCommand sqlSelectCommand1;
		private System.Data.SqlClient.SqlCommand sqlInsertCommand1;
		private System.Data.SqlClient.SqlCommand sqlUpdateCommand1;
		private System.Data.SqlClient.SqlCommand sqlDeleteCommand1;
		private System.Data.SqlClient.SqlConnection sqlConnection1;
		private System.Data.SqlClient.SqlDataAdapter sqlDataAdapter1;
		private MultipleRecordSelection.DataSet1 dataSet11;
		private System.Data.SqlClient.SqlCommand sqlSelectCommand2;
		private System.Data.SqlClient.SqlCommand sqlInsertCommand2;
		private System.Data.SqlClient.SqlCommand sqlUpdateCommand2;
		private System.Data.SqlClient.SqlCommand sqlDeleteCommand2;
		private System.Data.SqlClient.SqlDataAdapter sqlDataAdapter2;
		private System.Data.SqlClient.SqlConnection sqlConnection2;
		private System.Data.SqlClient.SqlCommand sqlSelectCommand3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.gridGroupingControl1.TableControl.ScrollControlMouseDown += new Syncfusion.Windows.Forms.CancelMouseEventHandler(ScrollControlMouseDown);


			//this.gridGroupingControl1.Appearance.AnyCell.Borders.All = GridBorder.Empty;
			//this.gridGroupingControl1.TableModel.Options.DefaultGridBorderStyle = GridBorderStyle.None;

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			bool msdeAvailable = false;
			if (msdeAvailable)
			{
				this.sqlDataAdapter1.Fill(this.dataSet11);
				this.sqlDataAdapter2.Fill(this.dataSet11);
			}
			else
			{
				// Read from a xml file instead.
				ReadXml(this.dataSet11, "Data\\HVData.xml");
			}
			this.Load += new EventHandler(Form1_Load);

			this.gridGroupingControl1.AddGroupDropArea("Orders");

			this.gridGroupingControl1.NestedTableGroupOptions.ShowCaptionPlusMinus = false;
			this.gridGroupingControl1.NestedTableGroupOptions.ShowCaption = false;
			this.gridGroupingControl1.ChildGroupOptions.ShowCaptionPlusMinus = false;

			if (this.gridGroupingControl1.Table.Records.Count > 4
				&& this.gridGroupingControl1.Table.Records[2].NestedTables.Count > 0)
			{
				this.gridGroupingControl1.Table.Records[2].IsExpanded = true;
				this.gridGroupingControl1.Table.Records[2].NestedTables[0].IsExpanded = true;
				this.gridGroupingControl1.Table.Records[4].IsExpanded = true;
				this.gridGroupingControl1.Table.Records[4].NestedTables[0].IsExpanded = true;
			}

			//this.gridGroupingControl1.Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.ShowCurrentRow;
			//this.gridGroupingControl1.TableControlPrepareViewStyleInfo += new GridTableControlPrepareViewStyleInfoEventHandler(gridGroupingControl1_TableControlPrepareViewStyleInfo);
			this.gridGroupingControl1.Appearance.GroupCaptionCell.Enabled = true;
			//this.gridGroupingControl1.TableControlMoveCurrentCellDirection += new GridTableControlMoveCurrentCellDirectionEventHandler(gridGroupingControl1_TableControlMoveCurrentCellDirection);
			this.gridGroupingControl1.IntelliMousePanning = true;


			this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.MultiExtended;
			this.gridGroupingControl1.TableOptions.AllowSelection = GridSelectionFlags.None;
			this.gridGroupingControl1.TableOptions.ListBoxSelectionColorOptions = GridListBoxSelectionColorOptions.ApplySelectionColor;
			this.gridGroupingControl1.TableOptions.ListBoxSelectionCurrentCellOptions = GridListBoxSelectionCurrentCellOptions.WhiteCurrentCell
				|GridListBoxSelectionCurrentCellOptions.MoveCurrentCellWithMouse;
			
		}

		void ReadXml(DataSet ds, string xmlFileName)
		{
			for (int n = 0; n < 10; n++)
			{
				if (System.IO.File.Exists(xmlFileName))
				{
					ds.ReadXml(xmlFileName);
					break;
				}
				xmlFileName = @"..\" + xmlFileName;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new DerGridGroupingControl();
			this.dataSet11 = new MultipleRecordSelection.DataSet1();
			this.sqlSelectCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlConnection1 = new System.Data.SqlClient.SqlConnection();
			this.sqlInsertCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlUpdateCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlDeleteCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlDataAdapter1 = new System.Data.SqlClient.SqlDataAdapter();
			this.sqlSelectCommand2 = new System.Data.SqlClient.SqlCommand();
			this.sqlInsertCommand2 = new System.Data.SqlClient.SqlCommand();
			this.sqlUpdateCommand2 = new System.Data.SqlClient.SqlCommand();
			this.sqlDeleteCommand2 = new System.Data.SqlClient.SqlCommand();
			this.sqlDataAdapter2 = new System.Data.SqlClient.SqlDataAdapter();
			this.sqlConnection2 = new System.Data.SqlClient.SqlConnection();
			this.sqlSelectCommand3 = new System.Data.SqlClient.SqlCommand();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataSet11)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Appearance.AlternateRecordFieldCell.BaseStyle = "";
			this.gridGroupingControl1.Appearance.AnyCell.BaseStyle = "";
			this.gridGroupingControl1.Appearance.AnyCell.TextColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(21)), ((System.Byte)(84)));
			this.gridGroupingControl1.Appearance.AnyIndentCell.BaseStyle = "";
			this.gridGroupingControl1.Appearance.NestedTableRowHeaderCell.BaseStyle = "";
			this.gridGroupingControl1.Appearance.NestedTableRowHeaderCell.CellType = "RowHeaderCell";
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.ChildGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridGroupingControl1.DataSource = this.dataSet11.Customers;
			this.gridGroupingControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = true;
			this.gridGroupingControl1.NestedTableGroupOptions.ShowCaptionPlusMinus = true;
			this.gridGroupingControl1.NestedTableGroupOptions.ShowGroupPreview = true;
			this.gridGroupingControl1.ShowGroupDropArea = true;
			this.gridGroupingControl1.ShowNavigationBar = true;
			this.gridGroupingControl1.ShowNavigationBarToolTips = true;
			this.gridGroupingControl1.Size = new System.Drawing.Size(727, 701);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableOptions.ShowTableIndentAsCoveredRange = true;
			this.gridGroupingControl1.TableOptions.ShowTableRowHeaderAsCoveredRange = true;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			// 
			// dataSet11
			// 
			this.dataSet11.DataSetName = "DataSet1";
			this.dataSet11.Locale = new System.Globalization.CultureInfo("en-US");
			this.dataSet11.Namespace = "http://www.tempuri.org/DataSet1.xsd";
			// 
			// sqlSelectCommand1
			// 
			this.sqlSelectCommand1.CommandText = "SELECT CustomerID, CompanyName, ContactName, ContactTitle, Address, City, Region," +
				" PostalCode, Country, Phone, Fax FROM Customers";
			this.sqlSelectCommand1.Connection = this.sqlConnection1;
			// 
			// sqlConnection1
			// 
			this.sqlConnection1.ConnectionString = "data source=(local)\\NETSDK;initial catalog=Northwind;integrated security=SSPI;per" +
				"sist security info=True;workstation id=localhost;packet size=4096";
			// 
			// sqlInsertCommand1
			// 
			this.sqlInsertCommand1.CommandText = @"INSERT INTO Customers(CustomerID, CompanyName, ContactName, ContactTitle, Address, City, Region, PostalCode, Country, Phone, Fax) VALUES (@CustomerID, @CompanyName, @ContactName, @ContactTitle, @Address, @City, @Region, @PostalCode, @Country, @Phone, @Fax); SELECT CustomerID, CompanyName, ContactName, ContactTitle, Address, City, Region, PostalCode, Country, Phone, Fax FROM Customers WHERE (CustomerID = @CustomerID)";
			this.sqlInsertCommand1.Connection = this.sqlConnection1;
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CustomerID", System.Data.SqlDbType.NVarChar, 5, "CustomerID"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CompanyName", System.Data.SqlDbType.NVarChar, 40, "CompanyName"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ContactName", System.Data.SqlDbType.NVarChar, 30, "ContactName"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ContactTitle", System.Data.SqlDbType.NVarChar, 30, "ContactTitle"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Address", System.Data.SqlDbType.NVarChar, 60, "Address"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@City", System.Data.SqlDbType.NVarChar, 15, "City"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Region", System.Data.SqlDbType.NVarChar, 15, "Region"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@PostalCode", System.Data.SqlDbType.NVarChar, 10, "PostalCode"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Country", System.Data.SqlDbType.NVarChar, 15, "Country"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Phone", System.Data.SqlDbType.NVarChar, 24, "Phone"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Fax", System.Data.SqlDbType.NVarChar, 24, "Fax"));
			// 
			// sqlUpdateCommand1
			// 
			this.sqlUpdateCommand1.CommandText = @"UPDATE Customers SET CustomerID = @CustomerID, CompanyName = @CompanyName, ContactName = @ContactName, ContactTitle = @ContactTitle, Address = @Address, City = @City, Region = @Region, PostalCode = @PostalCode, Country = @Country, Phone = @Phone, Fax = @Fax WHERE (CustomerID = @Original_CustomerID) AND (Address = @Original_Address OR @Original_Address IS NULL AND Address IS NULL) AND (City = @Original_City OR @Original_City IS NULL AND City IS NULL) AND (CompanyName = @Original_CompanyName) AND (ContactName = @Original_ContactName OR @Original_ContactName IS NULL AND ContactName IS NULL) AND (ContactTitle = @Original_ContactTitle OR @Original_ContactTitle IS NULL AND ContactTitle IS NULL) AND (Country = @Original_Country OR @Original_Country IS NULL AND Country IS NULL) AND (Fax = @Original_Fax OR @Original_Fax IS NULL AND Fax IS NULL) AND (Phone = @Original_Phone OR @Original_Phone IS NULL AND Phone IS NULL) AND (PostalCode = @Original_PostalCode OR @Original_PostalCode IS NULL AND PostalCode IS NULL) AND (Region = @Original_Region OR @Original_Region IS NULL AND Region IS NULL); SELECT CustomerID, CompanyName, ContactName, ContactTitle, Address, City, Region, PostalCode, Country, Phone, Fax FROM Customers WHERE (CustomerID = @CustomerID)";
			this.sqlUpdateCommand1.Connection = this.sqlConnection1;
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CustomerID", System.Data.SqlDbType.NVarChar, 5, "CustomerID"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CompanyName", System.Data.SqlDbType.NVarChar, 40, "CompanyName"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ContactName", System.Data.SqlDbType.NVarChar, 30, "ContactName"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ContactTitle", System.Data.SqlDbType.NVarChar, 30, "ContactTitle"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Address", System.Data.SqlDbType.NVarChar, 60, "Address"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@City", System.Data.SqlDbType.NVarChar, 15, "City"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Region", System.Data.SqlDbType.NVarChar, 15, "Region"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@PostalCode", System.Data.SqlDbType.NVarChar, 10, "PostalCode"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Country", System.Data.SqlDbType.NVarChar, 15, "Country"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Phone", System.Data.SqlDbType.NVarChar, 24, "Phone"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Fax", System.Data.SqlDbType.NVarChar, 24, "Fax"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CustomerID", System.Data.SqlDbType.NVarChar, 5, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CustomerID", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Address", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Address", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_City", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "City", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CompanyName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CompanyName", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ContactName", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ContactName", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ContactTitle", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ContactTitle", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Country", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Country", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Fax", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Fax", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Phone", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Phone", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_PostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "PostalCode", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Region", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Region", System.Data.DataRowVersion.Original, null));
			// 
			// sqlDeleteCommand1
			// 
			this.sqlDeleteCommand1.CommandText = @"DELETE FROM Customers WHERE (CustomerID = @Original_CustomerID) AND (Address = @Original_Address OR @Original_Address IS NULL AND Address IS NULL) AND (City = @Original_City OR @Original_City IS NULL AND City IS NULL) AND (CompanyName = @Original_CompanyName) AND (ContactName = @Original_ContactName OR @Original_ContactName IS NULL AND ContactName IS NULL) AND (ContactTitle = @Original_ContactTitle OR @Original_ContactTitle IS NULL AND ContactTitle IS NULL) AND (Country = @Original_Country OR @Original_Country IS NULL AND Country IS NULL) AND (Fax = @Original_Fax OR @Original_Fax IS NULL AND Fax IS NULL) AND (Phone = @Original_Phone OR @Original_Phone IS NULL AND Phone IS NULL) AND (PostalCode = @Original_PostalCode OR @Original_PostalCode IS NULL AND PostalCode IS NULL) AND (Region = @Original_Region OR @Original_Region IS NULL AND Region IS NULL)";
			this.sqlDeleteCommand1.Connection = this.sqlConnection1;
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CustomerID", System.Data.SqlDbType.NVarChar, 5, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CustomerID", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Address", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Address", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_City", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "City", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CompanyName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CompanyName", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ContactName", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ContactName", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ContactTitle", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ContactTitle", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Country", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Country", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Fax", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Fax", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Phone", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Phone", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_PostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "PostalCode", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Region", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Region", System.Data.DataRowVersion.Original, null));
			// 
			// sqlDataAdapter1
			// 
			this.sqlDataAdapter1.DeleteCommand = this.sqlDeleteCommand1;
			this.sqlDataAdapter1.InsertCommand = this.sqlInsertCommand1;
			this.sqlDataAdapter1.SelectCommand = this.sqlSelectCommand1;
			this.sqlDataAdapter1.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									  new System.Data.Common.DataTableMapping("Table", "Customers", new System.Data.Common.DataColumnMapping[] {
																																																				   new System.Data.Common.DataColumnMapping("CustomerID", "CustomerID"),
																																																				   new System.Data.Common.DataColumnMapping("CompanyName", "CompanyName"),
																																																				   new System.Data.Common.DataColumnMapping("ContactName", "ContactName"),
																																																				   new System.Data.Common.DataColumnMapping("ContactTitle", "ContactTitle"),
																																																				   new System.Data.Common.DataColumnMapping("Address", "Address"),
																																																				   new System.Data.Common.DataColumnMapping("City", "City"),
																																																				   new System.Data.Common.DataColumnMapping("Region", "Region"),
																																																				   new System.Data.Common.DataColumnMapping("PostalCode", "PostalCode"),
																																																				   new System.Data.Common.DataColumnMapping("Country", "Country"),
																																																				   new System.Data.Common.DataColumnMapping("Phone", "Phone"),
																																																				   new System.Data.Common.DataColumnMapping("Fax", "Fax")})});
			this.sqlDataAdapter1.UpdateCommand = this.sqlUpdateCommand1;
			// 
			// sqlSelectCommand2
			// 
			this.sqlSelectCommand2.CommandText = "SELECT OrderID, CustomerID, EmployeeID, OrderDate, RequiredDate, ShippedDate, Shi" +
				"pVia, Freight, ShipName, ShipAddress, ShipCity, ShipRegion, ShipPostalCode, Ship" +
				"Country FROM Orders";
			this.sqlSelectCommand2.Connection = this.sqlConnection1;
			// 
			// sqlInsertCommand2
			// 
			this.sqlInsertCommand2.CommandText = @"INSERT INTO Orders(CustomerID, EmployeeID, OrderDate, RequiredDate, ShippedDate, ShipVia, Freight, ShipName, ShipAddress, ShipCity, ShipRegion, ShipPostalCode, ShipCountry) VALUES (@CustomerID, @EmployeeID, @OrderDate, @RequiredDate, @ShippedDate, @ShipVia, @Freight, @ShipName, @ShipAddress, @ShipCity, @ShipRegion, @ShipPostalCode, @ShipCountry); SELECT OrderID, CustomerID, EmployeeID, OrderDate, RequiredDate, ShippedDate, ShipVia, Freight, ShipName, ShipAddress, ShipCity, ShipRegion, ShipPostalCode, ShipCountry FROM Orders WHERE (OrderID = @@IDENTITY)";
			this.sqlInsertCommand2.Connection = this.sqlConnection1;
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CustomerID", System.Data.SqlDbType.NVarChar, 5, "CustomerID"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@EmployeeID", System.Data.SqlDbType.Int, 4, "EmployeeID"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@OrderDate", System.Data.SqlDbType.DateTime, 8, "OrderDate"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@RequiredDate", System.Data.SqlDbType.DateTime, 8, "RequiredDate"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShippedDate", System.Data.SqlDbType.DateTime, 8, "ShippedDate"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipVia", System.Data.SqlDbType.Int, 4, "ShipVia"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Freight", System.Data.SqlDbType.Money, 8, "Freight"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipName", System.Data.SqlDbType.NVarChar, 40, "ShipName"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipAddress", System.Data.SqlDbType.NVarChar, 60, "ShipAddress"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipCity", System.Data.SqlDbType.NVarChar, 15, "ShipCity"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipRegion", System.Data.SqlDbType.NVarChar, 15, "ShipRegion"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipPostalCode", System.Data.SqlDbType.NVarChar, 10, "ShipPostalCode"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipCountry", System.Data.SqlDbType.NVarChar, 15, "ShipCountry"));
			// 
			// sqlUpdateCommand2
			// 
			this.sqlUpdateCommand2.CommandText = "UPDATE Orders SET CustomerID = @CustomerID, EmployeeID = @EmployeeID, OrderDate =" +
				" @OrderDate, RequiredDate = @RequiredDate, ShippedDate = @ShippedDate, ShipVia =" +
				" @ShipVia, Freight = @Freight, ShipName = @ShipName, ShipAddress = @ShipAddress," +
				" ShipCity = @ShipCity, ShipRegion = @ShipRegion, ShipPostalCode = @ShipPostalCod" +
				"e, ShipCountry = @ShipCountry WHERE (OrderID = @Original_OrderID) AND (CustomerI" +
				"D = @Original_CustomerID OR @Original_CustomerID IS NULL AND CustomerID IS NULL)" +
				" AND (EmployeeID = @Original_EmployeeID OR @Original_EmployeeID IS NULL AND Empl" +
				"oyeeID IS NULL) AND (Freight = @Original_Freight OR @Original_Freight IS NULL AN" +
				"D Freight IS NULL) AND (OrderDate = @Original_OrderDate OR @Original_OrderDate I" +
				"S NULL AND OrderDate IS NULL) AND (RequiredDate = @Original_RequiredDate OR @Ori" +
				"ginal_RequiredDate IS NULL AND RequiredDate IS NULL) AND (ShipAddress = @Origina" +
				"l_ShipAddress OR @Original_ShipAddress IS NULL AND ShipAddress IS NULL) AND (Shi" +
				"pCity = @Original_ShipCity OR @Original_ShipCity IS NULL AND ShipCity IS NULL) A" +
				"ND (ShipCountry = @Original_ShipCountry OR @Original_ShipCountry IS NULL AND Shi" +
				"pCountry IS NULL) AND (ShipName = @Original_ShipName OR @Original_ShipName IS NU" +
				"LL AND ShipName IS NULL) AND (ShipPostalCode = @Original_ShipPostalCode OR @Orig" +
				"inal_ShipPostalCode IS NULL AND ShipPostalCode IS NULL) AND (ShipRegion = @Origi" +
				"nal_ShipRegion OR @Original_ShipRegion IS NULL AND ShipRegion IS NULL) AND (Ship" +
				"Via = @Original_ShipVia OR @Original_ShipVia IS NULL AND ShipVia IS NULL) AND (S" +
				"hippedDate = @Original_ShippedDate OR @Original_ShippedDate IS NULL AND ShippedD" +
				"ate IS NULL); SELECT OrderID, CustomerID, EmployeeID, OrderDate, RequiredDate, S" +
				"hippedDate, ShipVia, Freight, ShipName, ShipAddress, ShipCity, ShipRegion, ShipP" +
				"ostalCode, ShipCountry FROM Orders WHERE (OrderID = @OrderID)";
			this.sqlUpdateCommand2.Connection = this.sqlConnection1;
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CustomerID", System.Data.SqlDbType.NVarChar, 5, "CustomerID"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@EmployeeID", System.Data.SqlDbType.Int, 4, "EmployeeID"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@OrderDate", System.Data.SqlDbType.DateTime, 8, "OrderDate"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@RequiredDate", System.Data.SqlDbType.DateTime, 8, "RequiredDate"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShippedDate", System.Data.SqlDbType.DateTime, 8, "ShippedDate"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipVia", System.Data.SqlDbType.Int, 4, "ShipVia"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Freight", System.Data.SqlDbType.Money, 8, "Freight"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipName", System.Data.SqlDbType.NVarChar, 40, "ShipName"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipAddress", System.Data.SqlDbType.NVarChar, 60, "ShipAddress"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipCity", System.Data.SqlDbType.NVarChar, 15, "ShipCity"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipRegion", System.Data.SqlDbType.NVarChar, 15, "ShipRegion"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipPostalCode", System.Data.SqlDbType.NVarChar, 10, "ShipPostalCode"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ShipCountry", System.Data.SqlDbType.NVarChar, 15, "ShipCountry"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_OrderID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "OrderID", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CustomerID", System.Data.SqlDbType.NVarChar, 5, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CustomerID", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_EmployeeID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "EmployeeID", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Freight", System.Data.SqlDbType.Money, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Freight", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_OrderDate", System.Data.SqlDbType.DateTime, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "OrderDate", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_RequiredDate", System.Data.SqlDbType.DateTime, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "RequiredDate", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipAddress", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipAddress", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipCity", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipCity", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipCountry", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipCountry", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipName", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipPostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipPostalCode", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipRegion", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipRegion", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipVia", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipVia", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShippedDate", System.Data.SqlDbType.DateTime, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShippedDate", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@OrderID", System.Data.SqlDbType.Int, 4, "OrderID"));
			// 
			// sqlDeleteCommand2
			// 
			this.sqlDeleteCommand2.CommandText = @"DELETE FROM Orders WHERE (OrderID = @Original_OrderID) AND (CustomerID = @Original_CustomerID OR @Original_CustomerID IS NULL AND CustomerID IS NULL) AND (EmployeeID = @Original_EmployeeID OR @Original_EmployeeID IS NULL AND EmployeeID IS NULL) AND (Freight = @Original_Freight OR @Original_Freight IS NULL AND Freight IS NULL) AND (OrderDate = @Original_OrderDate OR @Original_OrderDate IS NULL AND OrderDate IS NULL) AND (RequiredDate = @Original_RequiredDate OR @Original_RequiredDate IS NULL AND RequiredDate IS NULL) AND (ShipAddress = @Original_ShipAddress OR @Original_ShipAddress IS NULL AND ShipAddress IS NULL) AND (ShipCity = @Original_ShipCity OR @Original_ShipCity IS NULL AND ShipCity IS NULL) AND (ShipCountry = @Original_ShipCountry OR @Original_ShipCountry IS NULL AND ShipCountry IS NULL) AND (ShipName = @Original_ShipName OR @Original_ShipName IS NULL AND ShipName IS NULL) AND (ShipPostalCode = @Original_ShipPostalCode OR @Original_ShipPostalCode IS NULL AND ShipPostalCode IS NULL) AND (ShipRegion = @Original_ShipRegion OR @Original_ShipRegion IS NULL AND ShipRegion IS NULL) AND (ShipVia = @Original_ShipVia OR @Original_ShipVia IS NULL AND ShipVia IS NULL) AND (ShippedDate = @Original_ShippedDate OR @Original_ShippedDate IS NULL AND ShippedDate IS NULL)";
			this.sqlDeleteCommand2.Connection = this.sqlConnection1;
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_OrderID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "OrderID", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CustomerID", System.Data.SqlDbType.NVarChar, 5, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CustomerID", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_EmployeeID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "EmployeeID", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Freight", System.Data.SqlDbType.Money, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Freight", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_OrderDate", System.Data.SqlDbType.DateTime, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "OrderDate", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_RequiredDate", System.Data.SqlDbType.DateTime, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "RequiredDate", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipAddress", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipAddress", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipCity", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipCity", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipCountry", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipCountry", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipName", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipPostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipPostalCode", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipRegion", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipRegion", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShipVia", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShipVia", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ShippedDate", System.Data.SqlDbType.DateTime, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShippedDate", System.Data.DataRowVersion.Original, null));
			// 
			// sqlDataAdapter2
			// 
			this.sqlDataAdapter2.DeleteCommand = this.sqlDeleteCommand2;
			this.sqlDataAdapter2.InsertCommand = this.sqlInsertCommand2;
			this.sqlDataAdapter2.SelectCommand = this.sqlSelectCommand2;
			this.sqlDataAdapter2.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									  new System.Data.Common.DataTableMapping("Table", "Orders", new System.Data.Common.DataColumnMapping[] {
																																																				new System.Data.Common.DataColumnMapping("OrderID", "OrderID"),
																																																				new System.Data.Common.DataColumnMapping("CustomerID", "CustomerID"),
																																																				new System.Data.Common.DataColumnMapping("EmployeeID", "EmployeeID"),
																																																				new System.Data.Common.DataColumnMapping("OrderDate", "OrderDate"),
																																																				new System.Data.Common.DataColumnMapping("RequiredDate", "RequiredDate"),
																																																				new System.Data.Common.DataColumnMapping("ShippedDate", "ShippedDate"),
																																																				new System.Data.Common.DataColumnMapping("ShipVia", "ShipVia"),
																																																				new System.Data.Common.DataColumnMapping("Freight", "Freight"),
																																																				new System.Data.Common.DataColumnMapping("ShipName", "ShipName"),
																																																				new System.Data.Common.DataColumnMapping("ShipAddress", "ShipAddress"),
																																																				new System.Data.Common.DataColumnMapping("ShipCity", "ShipCity"),
																																																				new System.Data.Common.DataColumnMapping("ShipRegion", "ShipRegion"),
																																																				new System.Data.Common.DataColumnMapping("ShipPostalCode", "ShipPostalCode"),
																																																				new System.Data.Common.DataColumnMapping("ShipCountry", "ShipCountry")})});
			this.sqlDataAdapter2.UpdateCommand = this.sqlUpdateCommand2;
			// 
			// sqlConnection2
			// 
			this.sqlConnection2.ConnectionString = "data source=(local)\\NETSDK;initial catalog=Northwind;integrated security=SSPI;per" +
				"sist security info=True;workstation id=localhost;packet size=4096";
			// 
			// sqlSelectCommand3
			// 
			this.sqlSelectCommand3.CommandText = "SELECT ShipperID, CompanyName, Phone FROM Shippers";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(727, 701);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridGroupingControl1});
			this.Name = "Form1";
			this.Text = "Syncfusion Essential Grid - MultipleRecordSelection";
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataSet11)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			GroupingGridPropertyDialog frm = new GroupingGridPropertyDialog(this.gridGroupingControl1);
			Rectangle r = System.Windows.Forms.SystemInformation.WorkingArea;
			frm.Size = new Size(350, 500);
			r = Rectangle.FromLTRB(r.Right-frm.Width, r.Top, r.Right, frm.Height);
			frm.Bounds = r;
			frm.Visible = true;
			frm.Bounds = r;
		}

		void ScrollControlMouseDown(object sender, Syncfusion.Windows.Forms.CancelMouseEventArgs e)
		{

			GridTableControl tablec = this.gridGroupingControl1.TableControl;
			GridTableCellStyleInfo style = this.gridGroupingControl1.PointToTableCellStyle(new Point(e.MouseEventArgs.X, e.MouseEventArgs.Y));

			if (style.TableCellIdentity != null && 
				(style.TableCellIdentity.TableCellType == GridTableCellType.RecordRowHeaderCell
				|| style.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordRowHeaderCell))
			{
				if (style.TableCellIdentity.DisplayElement == null)
					return;

				Record r;
				if (style.TableCellIdentity.DisplayElement is Record)
					r = (Record) style.TableCellIdentity.DisplayElement;
				else
					r = style.TableCellIdentity.DisplayElement.ParentRecord;

				if (r.ParentTable.SelectedRecords.Contains(r))
					// remove selection
					r.ParentTable.SelectedRecords.Remove(r);
				else
				{
					// Add selection
					r.ParentTable.SelectedRecords.Add(r);

					// start drag drop
					Timer t = new Timer();
					t.Tick += new EventHandler(t_tick);
					t.Interval = 5;
					t.Start();

					dragRecord = r;
				}

				e.Cancel = true;

			}

		}

		Record dragRecord;

		void t_tick(object sender, EventArgs e)
		{
			((Timer) sender).Dispose();

			Record r = dragRecord;
			string test = "Record " + r.ParentChildTable.Records.IndexOf(r);
			this.gridGroupingControl1.Invalidate();
			GridTableControl tablec = this.gridGroupingControl1.TableControl;
			tablec.Update();
			tablec.DoDragDrop(test, DragDropEffects.All);
		}


	}

	public class DerGridGroupingControl : Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl
	{
		public DerGridGroupingControl() 
			: base(new DerivedEngine()) // use derived engine that implements of Cell Style and Identity Functions ported back from 3.2 to 3.0
		{
		}

		
		/// <summary>
		/// Sort the records in the parent table by the specified column
		/// </summary>
		/// <param name="columnName"></param>
		public void SortColumn(string columnName)
		{
			IBindingList sourceList = Engine.Table.SourceList as IBindingList;

			if ( sourceList != null )
			{
				ITypedList typedList = Engine.Table.SourceList as ITypedList;

				PropertyDescriptor propertyDescriptor = typedList.GetItemProperties(null)[columnName];

				if ( propertyDescriptor != null )
				{
					if ( sourceList.IsSorted && sourceList.SortProperty.Name == columnName)
					{
						if ( sourceList.SortDirection == ListSortDirection.Ascending )
							sourceList.ApplySort(propertyDescriptor, ListSortDirection.Descending);
						else
							sourceList.RemoveSort();
					}
					else
						sourceList.ApplySort(propertyDescriptor, ListSortDirection.Ascending);
				}
			}
		}

		bool SupportsYAmount = true;

		/// <summary>
		/// Determines the nested display element that is shown at the specified point.
		/// </summary>
		/// <param name="ptClient">The point in client coordinates</param>
		/// <returns>The display element.</returns>
		/// <remarks>
		/// <seealso cref="GridTableControl.PointToTableCellStyle"/>
		/// <seealso cref="GridTable.GetTableCellStyle"/>
		/// </remarks>
		public Element PointToNestedDisplayElement(GridTableControl tableControl, Point ptClient)
		{
			GridTable mainTable = tableControl.Table;

			// Get nested element that is displayed under cursor
			int yOffset =  tableControl.VScrollBar.Minimum;
			double yPosition = ptClient.Y;
			if (ptClient.Y > yOffset)
				yPosition = ptClient.Y - yOffset + tableControl.VScrollBar.Value; // Take current scroll position if mouse is over scrollable area.

			Element displayElement;
			if (SupportsYAmount)
				displayElement = mainTable.NestedDisplayElements.GetItemAtYAmount(yPosition);
			else
			{
				int rowIndex = tableControl.GetRow(tableControl.ViewLayout.PointToClientRow(ptClient, GridCellSizeKind.VisibleSize));
				displayElement = mainTable.NestedDisplayElements[rowIndex];
			}
			return displayElement;
		}

		/// <summary>
		/// Returns the style information for the cell that is displayed under a mouse position in client coordinates. If cell belongs to a nested
		/// table style information is returned for the cell inside the nested table. Good for hit-testing.
		/// </summary>
		/// <param name="ptClient">The mouse position in client coordinates.</param>
		/// <returns>The style element with identity information for the cell that is displayed at the specified coordinate.</returns>
		/// <remarks>
		/// <example>
		/// This example dumps information about the cell below a mouse cursor while the user is hovering the mouse
		/// over the grid.
		/// <code lang="C#">
		/// private void TableControl_MouseMove(object sender, MouseEventArgs e)
		/// {
		///     Point ptClient = new Point(e.X, e.Y);
		///     GridTableControl tableControl = this.groupingGrid1.TableControl;
		///
		///
		///     GridTableCellStyleInfo style = tableControl.PointToTableCellStyle(ptClient);
		///
		///     Element displayElement = style.TableCellIdentity.DisplayElement;
		///
		///     string info = "";
		///     if (style != null)
		///     {
		///         if (style.TableCellIdentity.Column != null)
		///             info = style.TableCellIdentity.Column.Name;
		///         else
		///             info = style.TableCellIdentity.ToString();
		///     }
		///
		///     Console.WriteLine("{0}: {1},{2},{3} ", ptClient, displayElement.ParentChildTable.CategoriesToString(), displayElement.GetType().Name, info);
		/// }
		/// </code>
		/// <code lang="VB">
		/// Private Sub TableControl_MouseMove(sender As Object, e As MouseEventArgs)
		///     Dim ptClient As New Point(e.X, e.Y)
		///     Dim tableControl As GridTableControl = Me.groupingGrid1.TableControl
		///
		///
		///     Dim style As GridTableCellStyleInfo = tableControl.PointToTableCellStyle(ptClient)
		///
		///     Dim displayElement As Element = style.TableCellIdentity.DisplayElement
		///
		///     Dim info As String = ""
		///     If Not (style Is Nothing) Then
		///         If Not (style.TableCellIdentity.Column Is Nothing) Then
		///             info = style.TableCellIdentity.Column.Name
		///         Else
		///             info = style.TableCellIdentity.ToString()
		///         End If
		///     End If
		///     Console.WriteLine("{0}: {1},{2},{3} ", ptClient, displayElement.ParentChildTable.CategoriesToString(), displayElement.GetType().Name, info)
		/// End Sub 'TableControl_MouseMove
		/// </code>
		/// </example>
		/// <seealso cref="GridTable.GetTableCellStyle"/>
		/// <seealso cref="GridTableControl.PointToNestedDisplayElement"/>
		/// </remarks>
		public GridTableCellStyleInfo PointToTableCellStyle(Point ptClient)
		{
			// Get nested element that is displayed under cursor
			Element displayElement = PointToNestedDisplayElement(ptClient);

			return ((DerivedTable) Table).GetTableCellStyle(displayElement, ptClient.X);
		}

		/// <summary>
		/// Determines the nested display element that is shown at the specified point.
		/// </summary>
		/// <param name="ptClient">The point in client coordinates</param>
		/// <returns>The display element.</returns>
		/// <remarks>
		/// <seealso cref="GridTableControl.PointToTableCellStyle"/>
		/// <seealso cref="GridTable.GetTableCellStyle"/>
		/// </remarks>
		public Element PointToNestedDisplayElement(Point ptClient)
		{
			GridTableControl tableControl = TableControl;
			GridTable mainTable = tableControl.Table;

			// Get nested element that is displayed under cursor
			int yOffset =  tableControl.VScrollBar.Minimum;
			double yPosition = ptClient.Y;
			if (ptClient.Y > yOffset)
				yPosition = ptClient.Y - yOffset + tableControl.VScrollBar.Value; // Take current scroll position if mouse is over scrollable area.

			Element displayElement;
			if (SupportsYAmount)
				displayElement = mainTable.NestedDisplayElements.GetItemAtYAmount(yPosition);
			else
			{
				int rowIndex = tableControl.GetRow(tableControl.ViewLayout.PointToClientRow(ptClient, GridCellSizeKind.VisibleSize));
				displayElement = mainTable.NestedDisplayElements[rowIndex];
			}
			return displayElement;
		}


		/// <summary>
		/// Returns the style information with TableCellIdentity for the given element and x-coordinate.
		/// </summary>
		/// <param name="element">The element</param>
		/// <param name="xPosition">The x position in client coordinate.</param>
		/// <returns>The style element with identity information for the cell that is displayed at the specified coordinate.</returns>
		/// <remarks>
		/// <seealso cref="GridTableControl.PointToTableCellStyle"/>
		/// <seealso cref="GridTableControl.PointToNestedDisplayElement"/>
		/// </remarks>
		public GridTableCellStyleInfo GetTableCellStyle(Element element, int xPosition)
		{
			/// // Get the tabledescriptor associated with that element
			GridTableDescriptor td = (GridTableDescriptor) element.ParentTableDescriptor;
			DerivedTable table = (DerivedTable) element.ParentTable;

			// Calculate nested indent for this table
			int indentWidth = table.GetTotalWidthOfRowHeadersAndIndent(true);

			if (indentWidth > xPosition)
			{
				// the mouse is over a row header or indent.
				return table.GetIndentTableCellStyle(element.ParentChildTable, element, xPosition);
			}

			GridTable mainTable = Engine.Table;

			int relativeRow = element is RowElement ? table.GetRelativeRowIndex((RowElement) element) : 0;

			// Get GridColumnDescriptor and column index (column index for the nested table)
			GridColumnDescriptor[,] recordRowColumns = td.RecordRowColumns;

			int colIndex = -1;
			int currentX = indentWidth;
			GridColumnDescriptor column = null;

			if (currentX <= xPosition)
			{
				// Check for column
				for (int n = 0; n < recordRowColumns.GetLength(1); n++)
				{
					column = recordRowColumns[relativeRow, n];
					if (column.Width + currentX > xPosition)
					{
						colIndex = n;
						break;
					}
					currentX += column.Width;
				}

				// Get the style
				if (colIndex != -1)
					return table.GetTableCellStyle(element, column.MappingName);
				else
					return table.GetIndentTableCellStyle(element.ParentChildTable, element, xPosition);
			}

			return null;
		}

		/// <summary>
		/// Invalidates the display area for the specified element.
		/// </summary>
		/// <param name="element"></param>
		public void InvalidateElement(Element element)
		{
			if (this.TableControl.Visible && element != null && element.GetVisibleInHierarchy())
			{
				GridTableControl tableControl = this.TableControl;
				Rectangle r = ElementToRectangle(element);
				if (tableControl.ClientRectangle.IntersectsWith(r))
					tableControl.Invalidate(r);
			}
		}

		/// <summary>
		/// Returns the display area for the specified element.
		/// </summary>
		/// <param name="element"></param>
		/// <returns>Rectangle.Empty if element is not visible; otherwise, the display area in client coordinates</returns>
		public Rectangle ElementToRectangle(Element element)
		{
			if (element == null)
				return Rectangle.Empty;

			GridTableControl tableControl = TableControl;

			if (SupportsYAmount)
			{
				int yOffset;
				if (element is NestedTable)
					yOffset = (int) this.Table.DisplayElements.GetYAmountPositionOf(element);
				else
					yOffset = (int) this.Table.NestedDisplayElements.GetYAmountPositionOf(element);
				int yAmount = (int) element.GetYAmountCount();
				int yTop = tableControl.GetVScrollPixelMinimum();
				int yBottom = tableControl.Bottom;
				int yPos = tableControl.GetCurrentVScrollPixelPos();

				Rectangle r = Rectangle.FromLTRB(0, Math.Max(yOffset - yPos + yTop, yTop), tableControl.Width, yOffset+yAmount - yPos + yTop);
				return r;
			}
			else
			{
				int row1;
				if (element is NestedTable)
					row1 = (int) this.Table.DisplayElements.IndexOf(element);
				else
					row1 = (int) this.Table.NestedDisplayElements.IndexOf(element);

				int rowCount = (int) element.GetVisibleCount();

				Rectangle r = tableControl.RangeInfoToRectangle(GridRangeInfo.Rows(row1, row1+rowCount-1));
				return r;
			}
		}

		/// <summary>
		/// Determines if the specified element is visible and scrolled into view
		/// </summary>
		/// <param name="element"></param>
		public bool IsElementVisible(Element element)
		{
			if (element != null && element.GetVisibleInHierarchy())
			{
				GridTableControl tableControl = TableControl;
				Rectangle r = ElementToRectangle(element);
				return tableControl.ClientRectangle.IntersectsWith(r);
			}

			return false;
		}


	}

	public class DerivedEngine : GridEngine
	{
		public override Table CreateTable(TableDescriptor tableDescriptor, Table parentTable)
		{
			return new DerivedTable ((GridTableDescriptor) tableDescriptor, (GridTable) parentTable);
		}
	}
	
	public class DerivedTable : GridTable
	{
		public DerivedTable (GridTableDescriptor tableDescriptor, GridTable parentTable)
			: base(tableDescriptor, parentTable)
		{
		}

		#region Backport of Cell Style and Identity Functions from 3.2 to 3.0

		/// <summary>
		/// Calculates the width of row headers and all indent columns before
		/// the first record column.
		/// </summary>
		/// <param name="includeWidthOfParentTableIndent">Specifies if width of nested table indents and parent table row headers should be added.</param>
		/// <returns></returns>
		public int GetTotalWidthOfRowHeadersAndIndent(bool includeWidthOfParentTableIndent)
		{
			if (!includeWidthOfParentTableIndent)
				return GetTotalWidthOfRowHeadersAndIndent();

			int indentWidth = GetTotalWidthOfRowHeadersAndIndent();
			GridTable parentTable = RelationParentTable;
			while (parentTable != null)
			{
				indentWidth += parentTable.GetTotalWidthOfRowHeadersAndIndent();
				parentTable = parentTable.RelationParentTable;
			}

			return indentWidth;
		}

		/// <summary>
		/// Returns the relative row index in the RowElements collection if displayElement is a RecordRow or ColumnHeader row.
		/// (A record can have column sets with multiple rows per record)
		/// </summary>
		/// <param name="rowElement">The row element</param>
		/// <returns>The relative row index of the element.</returns>
		public int GetRelativeRowIndex(RowElement rowElement)
		{
			int relativeRow = 0;

			Element parent = rowElement.ParentElement;

			if (rowElement is RecordRow)
				relativeRow = ((GridRecordRowsPart) parent).RowElements.IndexOf(rowElement);
			else if (parent is RowElementsSection)
				relativeRow = ((RowElementsSection) parent).RowElements.IndexOf(rowElement);
			//			else if (parent is IRowElementsContainer)
			//				relativeRow = ((IRowElementsContainer) parent).RowElements.IndexOf(rowElement);

			return relativeRow;
		}


		/// <summary>
		/// Returns the style information with TableCellIdentity for the given element and x-coordinate.
		/// </summary>
		/// <param name="element">The element</param>
		/// <param name="xPosition">The x position in client coordinate.</param>
		/// <returns>The style element with identity information for the cell that is displayed at the specified coordinate.</returns>
		/// <remarks>
		/// <seealso cref="GridTableControl.PointToTableCellStyle"/>
		/// <seealso cref="GridTableControl.PointToNestedDisplayElement"/>
		/// </remarks>
		public GridTableCellStyleInfo GetTableCellStyle(Element element, int xPosition)
		{
			/// // Get the tabledescriptor associated with that element
			GridTableDescriptor td = (GridTableDescriptor) element.ParentTableDescriptor;
			DerivedTable table = (DerivedTable) element.ParentTable;

			// Calculate nested indent for this table
			int indentWidth = table.GetTotalWidthOfRowHeadersAndIndent(true);

			if (indentWidth > xPosition)
			{
				// the mouse is over a row header or indent.
				return table.GetIndentTableCellStyle(element.ParentChildTable, element, xPosition);
			}

			GridTable mainTable = Engine.Table;

			int relativeRow = element is RowElement ? GetRelativeRowIndex((RowElement) element) : 0;

			// Get GridColumnDescriptor and column index (column index for the nested table)
			GridColumnDescriptor[,] recordRowColumns = td.RecordRowColumns;

			int colIndex = -1;
			int currentX = indentWidth;
			GridColumnDescriptor column = null;

			if (currentX <= xPosition)
			{
				// Check for column
				for (int n = 0; n < recordRowColumns.GetLength(1); n++)
				{
					column = recordRowColumns[relativeRow, n];
					if (column.Width + currentX > xPosition)
					{
						colIndex = n;
						break;
					}
					currentX += column.Width;
				}

				// Get the style
				if (colIndex != -1)
					return table.GetTableCellStyle(element, column.MappingName);
				else
					return table.GetIndentTableCellStyle(element.ParentChildTable, element, xPosition);
			}

			return null;
		}

		internal GridTableCellStyleInfo GetIndentTableCellStyle(ChildTable childTable, Element element, int xPosition)
		{
			int indentWidth = 0;

			DerivedTable parentTable = (DerivedTable) RelationParentTable;

			if (parentTable != null)
			{
				indentWidth = parentTable.GetTotalWidthOfRowHeadersAndIndent(true);

				if (indentWidth > xPosition)
				{
					// the mouse is over a row header or indent.
					return parentTable.GetIndentTableCellStyle(childTable.ParentNestedTable.ParentChildTable, element, xPosition);
				}
			}

			int width = indentWidth;
			int columnIndentCount = TableDescriptor.GetColumnIndentCount();

			int rowIndex = childTable.DisplayElements.IndexOf(element);

			width += this.DefaultRowHeaderWidth;
			if (xPosition < width)
			{
				return GetTableCellStyle(rowIndex, 0);
			}

			for (int n = 0; n < this.TableDescriptor.GroupedColumns.Count; n++)
			{
				width += DefaultIndentWidth;
				if (xPosition < width)
				{
					return GetTableCellStyle(rowIndex, n+1);
				}
			}

			if (this.TableDescriptor.Relations.NestedCount > 0)
			{
				width += this.DefaultTableIndentWidth;
				if (xPosition < width)
				{
					return GetTableCellStyle(rowIndex, TableDescriptor.GroupedColumns.Count+1);
				}
			}

			return GetTableCellStyle(rowIndex, TableDescriptor.GetColCount()); // empty cell after all columns
		}


		#endregion
	}



}